Loading...
Searching...
No Matches
Dune::Amg Namespace Reference
Iterative Solvers Template Library (ISTL) » Iterative Solvers » Preconditioners

## Classes

struct | ConstructionTraits
| Traits class for generically constructing non default constructable types. More...
class | AggregationCriterion
| Base class of all aggregation criterions. More...
class | SymmetricMatrixDependency
| Dependency policy for symmetric matrices. More...
class | Dependency
| Dependency policy for symmetric matrices. More...
class | SymmetricDependency
| Dependency policy for symmetric matrices. More...
class | Diagonal
| Norm that uses only the [N][N] entry of the block to determine couplings. More...
class | FirstDiagonal
| Norm that uses only the [0][0] entry of the block to determine couplings. More...
struct | RowSum
| Functor using the row sum (infinity) norm to determine strong couplings. More...
struct | FrobeniusNorm
struct | AlwaysOneNorm
class | SymmetricCriterion
| Criterion taking advantage of symmetric matrices. More...
class | UnSymmetricCriterion
| Criterion suitable for unsymmetric matrices. More...
class | Aggregator
| Class for building the aggregates. More...
class | AggregatesMap
| Class providing information about the mapping of the vertices onto aggregates. More...
class | Aggregate
| A class for temporarily storing the vertices of an aggregate in. More...
class | KAMG
| an algebraic multigrid method using a Krylov-cycle. More...
class | KAmgTwoGrid
| Two grid operator for AMG with Krylov cycle. More...
class | AMG
| Parallel algebraic multigrid based on agglomeration. More...
struct | DirectSolverSelector
struct | ApplyHelper
struct | ApplyHelper< 0 >
class | CombinedFunctor
struct | ConstructionTraits< BlockVector< T, A > >
struct | ParallelOperatorArgs
struct | OwnerOverlapCopyCommunicationArgs
struct | SequentialCommunicationArgs
struct | ConstructionTraits< OverlappingSchwarzOperator< M, X, Y, C > >
struct | ConstructionTraits< NonoverlappingSchwarzOperator< M, X, Y, C > >
struct | MatrixAdapterArgs
struct | ConstructionTraits< MatrixAdapter< M, X, Y > >
struct | ConstructionTraits< SequentialInformation >
struct | ConstructionTraits< OwnerOverlapCopyCommunication< T1, T2 > >
class | EdgeProperties
| Class representing the properties of an edge in the matrix graph. More...
class | VertexProperties
| Class representing a node in the matrix graph. More...
class | PropertyGraphVertexPropertyMap
class | FastAMG
| A fast (sequential) algebraic multigrid based on agglomeration that saves memory bandwidth. More...
struct | GaussSeidelPresmoothDefect
struct | GaussSeidelPostsmoothDefect
struct | OverlapVertex
class | SparsityBuilder
| Functor for building the sparsity pattern of the matrix using examineConnectivity. More...
class | BaseGalerkinProduct
class | GalerkinProduct
class | GalerkinProduct< SequentialInformation >
struct | BaseConnectivityConstructor
struct | ConnectivityConstructor
struct | ConnectivityConstructor< G, SequentialInformation >
struct | DirichletBoundarySetter
struct | DirichletBoundarySetter< SequentialInformation >
struct | GlobalAggregatesMap
struct | AggregatesGatherScatter
struct | AggregatesPublisher
struct | AggregatesPublisher< T, O, OwnerOverlapCopyCommunication< T1, T2 > >
| Utility class for publishing the aggregate number of the DOFs in the overlap to other processors and convert them to local indices. More...
struct | AggregatesPublisher< T, O, SequentialInformation >
class | MatrixGraph
| The (undirected) graph of a matrix. More...
class | SubGraph
| A subgraph of a graph. More...
class | VertexPropertiesGraph
| Attaches properties to the vertices of a graph. More...
class | PropertiesGraph
| Attaches properties to the edges and vertices of a graph. More...
class | GraphVertexPropertiesSelector
| Wrapper to access the internal edge properties of a graph via operator[](). More...
class | GraphEdgePropertiesSelector
| Wrapper to access the internal vertex properties of a graph via operator[](). More...
struct | PropertiesGraphCreator
struct | PropertiesGraphCreator< M, SequentialInformation >
class | Hierarchy
| A hierarchy of containers (e.g. matrices or vectors). More...
class | IndicesCoarsener
class | ParallelIndicesCoarsener
class | IndicesCoarsener< OwnerOverlapCopyCommunication< G, L >, E >
| Coarsen Indices in the parallel case. More...
class | IndicesCoarsener< SequentialInformation, E >
| Coarsen Indices in the sequential case. More...
class | MatrixHierarchy
| The hierarchies build by the coarsening process. More...
class | CoarsenCriterion
| The criterion describing the stop criteria for the coarsening process. More...
class | DependencyParameters
| Parameters needed to check whether a node depends on another. More...
class | AggregationParameters
| Parameters needed for the aggregation process. More...
class | CoarseningParameters
| Parameters for the complete coarsening process. More...
class | Parameters
| All parameters for AMG. More...
class | SequentialInformation
struct | VertexVisitedTag
| Tag idnetifying the visited property of a vertex. More...
class | RandomAccessBundledPropertyMap
| A property map that extracts one property out of a bundle using operator[](). More...
class | AggregateRenumberer
struct | DefaultSmootherArgs
| The default class for the smoother arguments. More...
struct | SmootherTraits
| Traits class for getting the attribute class of a smoother. More...
struct | SmootherTraits< Richardson< X, Y > >
struct | SmootherTraits< BlockPreconditioner< X, Y, C, T > >
struct | SmootherTraits< NonoverlappingBlockPreconditioner< C, T > >
class | DefaultConstructionArgs
| Construction Arguments for the default smoothers. More...
struct | ConstructionArgs
class | DefaultParallelConstructionArgs
class | DefaultConstructionArgs< Richardson< X, Y > >
struct | ConstructionTraits< SeqSSOR< M, X, Y, l > >
| Policy for the construction of the SeqSSOR smoother. More...
struct | ConstructionTraits< SeqSOR< M, X, Y, l > >
| Policy for the construction of the SeqSOR smoother. More...
struct | ConstructionTraits< SeqJac< M, X, Y, l > >
| Policy for the construction of the SeqJac smoother. More...
struct | ConstructionTraits< Richardson< X, Y > >
| Policy for the construction of the Richardson smoother. More...
class | ConstructionArgs< SeqILU< M, X, Y > >
struct | ConstructionTraits< SeqILU< M, X, Y > >
| Policy for the construction of the SeqILU smoother. More...
struct | ConstructionTraits< ParSSOR< M, X, Y, C > >
| Policy for the construction of the ParSSOR smoother. More...
struct | ConstructionTraits< BlockPreconditioner< X, Y, C, T > >
struct | ConstructionTraits< NonoverlappingBlockPreconditioner< C, T > >
struct | SmootherApplier
| Helper class for applying the smoothers. More...
struct | SmootherApplier< SeqSOR< M, X, Y, l > >
struct | SmootherApplier< BlockPreconditioner< X, Y, C, SeqSOR< M, X, Y, l > > >
struct | SmootherApplier< NonoverlappingBlockPreconditioner< C, SeqSOR< M, X, Y, l > > >
struct | SmootherApplier< SeqOverlappingSchwarz< M, X, MultiplicativeSchwarzMode, MS, TA > >
struct | SeqOverlappingSchwarzSmootherArgs
struct | SmootherTraits< SeqOverlappingSchwarz< M, X, TM, TS, TA > >
class | ConstructionArgs< SeqOverlappingSchwarz< M, X, TM, TS, TA > >
struct | ConstructionTraits< SeqOverlappingSchwarz< M, X, TM, TS, TA > >
class | Transfer
class | Transfer< V, V1, SequentialInformation >
class | Transfer< V, V1, OwnerOverlapCopyCommunication< T1, T2 > >
class | LevelTransferPolicy
| Abstract base class for transfer between levels and creation of the coarse level system. More...
class | AggregationLevelTransferPolicy
| A LeveTransferPolicy that used aggregation to construct the coarse level system. More...
class | OneStepAMGCoarseSolverPolicy
| A policy class for solving the coarse level system using one step of AMG. More...
class | TwoLevelMethod

## Enumerations

enum | { MAX_PROCESSES = 72000 }
enum | AccumulationMode { noAccu = 0 , atOnceAccu =1 , successiveAccu =2 }
| Identifiers for the different accumulation modes. More...

## Functions

template<class T>
std::ostream & | operator<< (std::ostream &os, const AggregationCriterion< T > &criterion)
template<class G, class C>
void | buildDependency (G &graph, const typename C::Matrix &matrix, C criterion, bool finestLevel)
| Build the dependency of the matrix graph.
template<class V>
void | printAggregates2d (const AggregatesMap< V > &aggregates, int n, int m, std::ostream &os)
std::ostream & | operator<< (std::ostream &os, const EdgeProperties &props)
std::ostream & | operator<< (std::ostream &os, const VertexProperties &props)
template<class G, class V>
int | visitNeighbours (const G &graph, const typename G::VertexDescriptor &vertex, V &visitor)
| Visit all neighbour vertices of a vertex in a graph.
template<typename M, typename C1>
bool | repartitionAndDistributeMatrix (const M &origMatrix, std::shared_ptr< M > newMatrix, SequentialInformation &origComm, std::shared_ptr< SequentialInformation > &newComm, RedistributeInformation< SequentialInformation > &ri, int nparts, C1 &criterion)
template<typename M, typename C, typename C1>
bool | repartitionAndDistributeMatrix (const M &origMatrix, std::shared_ptr< M > newMatrix, C &origComm, std::shared_ptr< C > &newComm, RedistributeInformation< C > &ri, int nparts, C1 &criterion)
template<class G, class I, class V>
void | renumberAggregates (const G &graph, I index, I endIndex, V &visitedMap, AggregatesMap< typename G::VertexDescriptor > &aggregates)
template<typename LevelContext>
void | presmooth (LevelContext &levelContext, size_t steps)
| Apply pre smoothing on the current level.
template<typename LevelContext>
void | postsmooth (LevelContext &levelContext, size_t steps)
| Apply post smoothing on the current level.

## Variables

template<typename T, typename TI>
const TI::GlobalIndex | GlobalAggregatesMap< T, TI >::isolatedMarker

## Function Documentation

## renumberAggregates()

template<class G, class I, class V>

void Dune::Amg::renumberAggregates | ( | const G & | graph,
|  | I | index,
|  | I | endIndex,
|  | V & | visitedMap,
|  | AggregatesMap< typename G::VertexDescriptor > & | aggregates )

## Variable Documentation

## GlobalAggregatesMap< T, TI >::isolatedMarker

template<typename T, typename TI>

const TI::GlobalIndex Dune::Amg::GlobalAggregatesMap< T, TI >::isolatedMarker

Initial value:
=
std::numeric_limits<typename TI::GlobalIndex>::max()